/*
 *  File:  Checkerboard.java
 *
 *  Draw a checkerboard pattern
 */

import java.awt.Color;
import java.awt.Graphics;

public class Checkerboard extends java.applet.Applet 
{
  int N = 6;

  public void paint(Graphics g) 
  {
    int rval, gval, bval;
    int x, y ;

    for (int j = 0; j < N; j++ )
    {  // y is the start point in vertical direction for each row of boxes
	y = j * 30;   

      for ( int i = 0; i < N; i++ )
      {  // x is the start point in horizontal direction for each box
	  // across the row
	  x = i * 30;   
 
        // decide color based on i and j
        if (((i + j) % 2) == 0 )
           g.setColor ( Color.black);
         else g.setColor ( Color.red ); 

         g.fillRect(x,y,25,25);
      }
    }
  }
}
