/* 
 * PatternRect.java - a pattern of Rectangles * 
 */

import java.applet.Applet;
import java.awt.*;

public class PatternRect extends Applet 
{
  // draws in the applet area (inside the browser window)
  public void paint( Graphics g ) 
  {
   // The variable x represents where to draw in the x direction (to the right)
   // The variables width and height control the size of the rectangles
    int x = 0;
    int width=20, height = 40;

    // sets the background of the applet area to be white
    // sets the current color to be cyan   
    setBackground ( Color.white);
    g.setColor( Color.cyan );

    // draw a sequence of  6 rectangle of varying size, evenly spaced
    for ( int i = 0;  i < 6;  i++ )
    {  x = x + 50;
       width = width + 4;
       height = height -4;
       g.fillRect( x, 10, width, height );
    }
  }
}

