/* 
 *  Draw.java
 *  Draw a shape on a canvas - control properties with buttons
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Draw extends Applet implements ActionListener
{
  Color mycolor;
  String myshape;
  int x, y;
  
  Canvas drawarea = new Canvas ( );
  Panel controls = new Panel ( ); 
  Panel first = new Panel ( );
  Panel second = new Panel ( );
  
  Button red, blue, green, magenta, redraw;
  TextField getshape, getx, gety; 
  Label label1, label2;
  
  public void init ( ) 
  {
    mycolor = Color.green;
    myshape = "rect";
    x = 50;  y = 50;
    setBackground ( Color.white );
    
    label1 = new Label ( "Type a shape and x,y location: " );
    first.add ( label1 );
    getshape = new TextField ( 6 );
    getx = new TextField ( 3 );
    gety = new TextField ( 3 );
    first.add ( getshape ); first.add ( getx ); first.add ( gety );
    redraw = new Button ( "redraw" );
    redraw.addActionListener ( this );
    first.add ( redraw );
    
    label2 = new Label ( "Select a color: " );
    second.add ( label2 );   
    red = new Button ( "red" ) ;
    red.addActionListener ( this );
    second.add ( red );
    blue = new Button ( "blue" ) ;
    blue.addActionListener ( this );
    second.add ( blue );
    green = new Button ( "green" ) ;
    green.addActionListener ( this );
    second.add ( green );
    magenta = new Button ( "magenta" ) ;
    magenta.addActionListener ( this );
    second.add ( magenta );
    
    controls.setLayout ( new GridLayout ( 2, 1 ));
    controls.add ( first );
    controls.add ( second );
    
    setLayout ( new BorderLayout ( ) );
    add ( drawarea, BorderLayout.CENTER );
    add ( controls, BorderLayout.SOUTH );
      }
  
  public void paint ( Graphics g ) 
  {
    g.setColor( mycolor );
    if (myshape.equals ("rect"))
    { g.fillRect ( x, y, 40, 40 ); }
    else
    { if (myshape.equals ("oval"))
       {g.fillOval ( x, y, 40, 40 );}
       }
    }
  
  public void actionPerformed ( ActionEvent event )
  {
    if ( event.getSource ( ) == red )
    {  mycolor = Color.red;  repaint ( ) ; }
    if ( event.getSource ( ) == blue )
    {  mycolor = Color.blue;  repaint ( ) ; }
    if ( event.getSource ( ) == green )
    {  mycolor = Color.green;  repaint ( ) ; }
    if ( event.getSource ( ) == magenta )
    {  mycolor = Color.magenta;  repaint ( ) ; }
    if ( event.getSource ( ) == redraw )
    {  
    }
    }
    
}

