/* 
 *  Drawshape.java
 *  Draw a shape on a canvas - control properties with buttons
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Drawshape extends Applet implements ActionListener
{
  Drawarea drawing = new Drawarea ( );
  Panel controls = new Panel ( ); 
  Panel first = new Panel ( );
  Panel second = new Panel ( );
  Panel third = new Panel ( );
  
  Button bluebutton, greenbutton, purplebutton, magentabutton ;
  TextField getshape, getx, gety; 
  Label label1, label2, label3;
  Button redraw, clear;
  Color purple = new Color ( 127, 0, 255 );
  Color beige = new Color ( 255, 255, 204 );
  
  public void init ( ) 
  {
    label1 = new Label ( "Shape (rect or oval): " );
    first.add ( label1 );
    getshape = new TextField ( 6 );
    first.add ( getshape );
    label2 = new Label ( "Location x and y: " );
    first.add ( label2 );
    getx = new TextField ( 3 );
    gety = new TextField ( 3 );
    first.add ( getx ); first.add ( gety );
     
    label3 = new Label ( "Select a color: " );
    second.add ( label3 );   
    bluebutton = new Button ( "blue" ) ;
    bluebutton.addActionListener ( this );
    second.add ( bluebutton );
    greenbutton = new Button ( "green" ) ;
    greenbutton.addActionListener ( this );
    second.add ( greenbutton );
    magentabutton = new Button ( "magenta" ) ;
    magentabutton.addActionListener ( this );
    second.add ( magentabutton );
    purplebutton = new Button ( "purple" ) ;
    purplebutton.addActionListener ( this );
    second.add ( purplebutton );
   
    redraw = new Button ( "redraw" );
    redraw.addActionListener ( this );
    third.add ( redraw );
    clear = new Button ( "clear" );
    clear.addActionListener ( this );
    third.add ( clear );

    
    controls.setLayout ( new GridLayout ( 3, 1 ));
    controls.add ( first );
    controls.add ( second );
    controls.add ( third );
    controls.setBackground ( beige );
    
    setLayout ( new BorderLayout ( ) );
    add ( drawing, BorderLayout.CENTER );
    add ( controls, BorderLayout.SOUTH );
      }
  
  public void paint ( Graphics g ) 
  {
    drawing.paint ( g );
    }
  
  public void actionPerformed ( ActionEvent event )
  {
     if ( event.getSource ( ) == bluebutton )
    {  drawing.mycolor = Color.blue;  }
    if ( event.getSource ( ) == greenbutton )
    {  drawing.mycolor = Color.green;  }
    if ( event.getSource ( ) == magentabutton )
    {  drawing.mycolor = Color.magenta;   }
     if ( event.getSource ( ) == purplebutton )
    {  drawing.mycolor = purple;  }

    
    if ( event.getSource ( ) == redraw )
     {  drawing.myshape = getshape.getText ( ) ;
        drawing.x = Integer.parseInt ( getx.getText ( ).trim ( ) );
        drawing.y = Integer.parseInt ( gety.getText ( ).trim ( ) );
        drawing.repaint ( ) ;
      }
      
      if ( event.getSource ( ) == clear )
      { drawing.myshape = "clear" ;
         drawing.repaint ( ) ;
       }
    }   
}

class Drawarea extends Canvas
{
  Color mycolor;
  String myshape;
  int x, y;
  
  public Drawarea ( )
  {
     setBackground ( Color.black );
     mycolor = Color.green;
     myshape = "rect";
      x = 50;  y = 50;
    }

  public void paint ( Graphics g ) 
  {
    g.setColor(mycolor );
    if ( myshape.equals ("rect"))
    { g.fillRect ( x, y, 40, 40 ); 
    }
    else
    { if ( myshape.equals ("oval"))
       {g.fillOval ( x, y, 40, 40 );
       }
     else
       { if ( myshape.equals ("clear"))
          { g.setColor ( getBackground ( ));
           g.fillRect ( 0, 0, getSize ( ).width, getSize ( ).height );
          }
        }
      }
    }
    
    public void update ( Graphics g )
    {  paint ( g );
    }
}