import java.awt.*;
import java.applet.*;

public class Bubbles extends java.applet.Applet implements Runnable
{ Image offscreenimg;
  Graphics offscreeng;
  final Color BCKCLR = Color.blue;
  Rising bubblesbackground;
  Rabbit bunnyrunning;
  Setting settingwindow;
  
  Event mouse;
  final long IDLE = 70;
  int height=500;
  int width=500;

  Thread artist=null;

  public boolean mouseDown (Event evt, int x, int y)
    { if (this.mouse != null)
	{ if (evt.clickCount == 3)
	    showStatus("TripleClick!");
	else if (evt.clickCount == 2)
	  { showStatus("DoubleClick!");
	    settingwindow.show();
//	    System.out.println("Requested Settingswindow");
	  }
	else
	  showStatus("Single Hit Again!");
	}
    else
      showStatus("First Hit!");
      this.mouse = evt;
      mouse.when=java.lang.System.currentTimeMillis();
      return true;
    }

  public boolean mouseUp (Event evt, int x, int y)
    { showStatus("Keeps on Going, and Going!");
      this.mouse = evt;
      mouse.when=java.lang.System.currentTimeMillis();
      return true; 
    }
  
  public boolean mouseMove (Event evt, int x, int y)
    { showStatus("The mouse is Moving... Can I catch it?");
      mouse = evt;
      mouse.when=java.lang.System.currentTimeMillis();
      return true;
    }
  
  public boolean mouseDrag (Event evt, int x, int y)
    { showStatus("Don't Drag your filthy mouse in here young man!");
      this.mouse = evt;
      mouse.when=java.lang.System.currentTimeMillis();
      return true;
    }

  public boolean mouseEnter (Event evt, int x, int y)
    { showStatus("The mouse is in the House... Oh My God, Oh My God!");
      this.mouse = evt;
      mouse.when=java.lang.System.currentTimeMillis();
      return true;
    }

  public boolean mouseExit (Event evt, int x, int y)
    { showStatus("Bye Bye Mr Mousy!");
      mouse=null;
      return true;
    }

  public void paint(Graphics g)
    { offscreeng.setColor(BCKCLR);
      offscreeng.fillRect(0, 0, width, height);
      if (mouse != null)  
	if ((java.lang.System.currentTimeMillis() - mouse.when) > IDLE)
	  { showStatus("Isn't the Resting Mouse cute?");
	    mouse = null;
	  }
      bunnyrunning.paint(offscreeng);
      bubblesbackground.paint(offscreeng);
      g.drawImage(offscreenimg, 0, 0, this);
//      System.out.println ("Paint Master "+bubblesbackground.thisbubble+" "+
//			  bubblesbackground.bubble);
    }

  public void myinit()
    { String temp;
      temp = getParameter("WIDTH");
      if (temp != null)
	width = Integer.parseInt(temp);
      temp = getParameter("HEIGHT");
      if (temp != null)
	height = Integer.parseInt(temp);
      setBackground(BCKCLR);
      bubblesbackground = new Rising(width, height, BCKCLR);
      bunnyrunning = new Rabbit(width, height, BCKCLR, 
				getImage(getCodeBase(), "ebunny.gif"));
      settingwindow = new Setting(bubblesbackground, bunnyrunning);
      resize(width, height);
      offscreenimg = createImage(width, height);
      offscreeng = offscreenimg.getGraphics();
//      System.out.println("Init Master");

    }

  public void start()
    { if (artist == null)
	{ artist = new Thread(this);
	  myinit();
	  artist.start();
	}
//      System.out.println("Start Master");
    }
  
  public void update (Graphics g)
    { paint(g);
//      System.out.println("Update Master");
    }

  public void stop()
    { artist = null;
      bubblesbackground.stop();
      bunnyrunning.stop();
      settingwindow.stop();
//      System.out.println("Stop Master");
    }

  public void run()
    { while (artist != null)
	{ try {Thread.sleep(100);} catch (InterruptedException e) {}
	  repaint();
//	  System.out.println("Run Master");
//	  Thread.yield();
	}
      artist = null;
    }
}
