import java.awt.*;
//import java.applet.*;

public class Rising implements Runnable
{ int loop, i, j, temp;
  final int TOTALBUBBLES = 100;
  final int TOTALSTEP = 50;
  final int TOTALRADIUS = 100;
  int bubble=0, thisbubble=0;
  int maxradius = 20;
  int maxbubbles = 40;
  int maxstep = 5;
  int bub[][] = new int[TOTALBUBBLES][5];
  int bubblespeed = 1;
  int w, h;
  Color BCKCOLOR;
  Thread bubblesthread;
  int ynew;

  Rising(int width, int height, Color col)
    { w = width;
      h = height;
      BCKCOLOR = col;
      start();
    }

  public void move_bubbles(int width, int height)
    { if ((bubble < maxbubbles) || (thisbubble < maxbubbles))
	{ bub[thisbubble][0]=(int)(Math.random() * width); /*XPosition*/
	  bub[thisbubble][1]=height-20;                    /*YPosition*/
	  bub[thisbubble][2]=(int)(Math.random() * 500) % maxradius;
	  bub[thisbubble][3]=(int)(Math.random() * 135) + 120; /*Color*/
	  bub[thisbubble][4]=(int)(Math.random() * maxstep) + 1;     /*Speed*/
	}
      if (bubble < maxbubbles)
	{ bubble++; thisbubble++; }
      else
	thisbubble = maxbubbles;
      for (i=0; i<bubble; i++)
	{ bub[i][1]-= bub[i][4]*bubblespeed;
	  for (j=0; j <i; j++)
	    { temp = ((bub[i][1]-bub[j][1])*(bub[i][1]-bub[j][1])+
		      (bub[i][0]-bub[j][0])*(bub[i][0]-bub[j][0]));
	      if (temp < ((bub[i][2]+bub[j][2])*((bub[i][2]+bub[j][2]))/2))
		{ bub[i][2]=-1;}
	    }
	  if (bub[i][2]+bub[i][1] > 0)
	    { temp = (int)(Math.random()*5)-2; bub[i][0]+=temp; }
	  else 
	    if (bubble >= maxbubbles)
	      { thisbubble = i; bubble--;}
	  
	}
//      System.out.println("Move Bubbles "+thisbubble+" "+bubble);
    }
  
  public void update(Graphics g)
    { paint(g);
//      System.out.println("Update Bubbles");
    }

  public void paint(Graphics offg)
    { for (loop=0; loop<bubble; loop++)
	{ if (bub[loop][2] != -1)
	    { offg.setColor(new Color(bub[loop][3], bub[loop][3], 255));
	      offg.drawOval(bub[loop][0], bub[loop][1], 
			    bub[loop][2], bub[loop][2]);
	      offg.drawOval(bub[loop][0]+(bub[loop][2]/2)+(bub[loop][0]&1), 
			    bub[loop][1]+(bub[loop][2]/5), 
			    (bub[loop][2]/7), (bub[loop][2]/6));

	    }
	}
//      System.out.println("Paint Bubbles");
    }
  
  public void start()
    { if (bubblesthread == null)
	{ bubblesthread = new Thread(this);
	  bubblesthread.start();
	}
//      System.out.println("Start Bubbles");
    }

  public void stop()
    { bubblesthread = null;
//      System.out.println("Stop Bubbles");
    }

  public void run()
    { while (bubblesthread!=null)
	{ try {Thread.sleep(100);} catch (InterruptedException e) {}
	  move_bubbles(w, h);
//	  Thread.yield();
	}
//      System.out.println("Run Bubbles");
    }
}

