/* 
 * PatternOval.java - a pattern of Rectangles * 
 */

import java.applet.Applet;
import java.awt.*;

public class PatternOval extends Applet 
{
   // draws in the applet area (inside the browser window)
  public void paint( Graphics g ) 
  {
    // The variable x represents where to draw in the x direction (to the right)
    // The variables width and height control the size of the rectangles
     int x = 0;
     int width=20, height = 20;

    // sets the background of the applet area to be white
    // sets the current color to be red   
    setBackground ( Color.white);
    g.setColor( Color.red );

    // draw a sequence of  6 ovals of varying size, varying spacing
    for ( int i = 0;  i < 6;  i++ )
    {  x = x + 25 + (i * 2);
       width = width + i * 2;
       height = height + i * 4;
       g.fillOval( x, 10, width, height );
    }
  }
}

