/* 
 * PatternSquare.java - a pattern of Squares * 
 */

import java.applet.Applet;
import java.awt.*;

public class PatternSquare extends Applet 
{
   // draws in the applet area (inside the browser window)
  public void paint( Graphics g ) 
  {
    // The variable x represents where to draw in the x direction (to the right)
    // The variable y represents where to draw in the y direction ( down )
     int x = 0, y = 0;

    // sets the background of the applet area to be white
    // sets the current color to be green
    setBackground ( Color.white);
    g.setColor( Color.green);

    // draw a sequence of  6 squares overlapping on the diagonal
     for ( int i = 0;  i < 6;  i++ )
    {  x = x + 20;
        y = y + 20;
       g.fillRect( x, y, 40, 40);
    }
  }
}

