/*  Numeric.java
 *   Prompts the user to type in numbers and computes 
 *   numeric operations.
  */

import java.awt.*;
import java.awt.event.*;

public class Numeric extends java.applet.Applet
	                	implements ActionListener
{
   Button addbutton, clearbutton;
   Label prompt1,prompt2;
   TextField input1, input2 ;
   TextField output ;
   Font medfont = new Font ("SansSerif", Font.PLAIN, 18 );

/*  This method is called once when the applet is downloaded, and
 *   defines the Labels, TextFields, and Buttons  that initially
 *  appear in the applet area.
 */
   public void init ( )
   {  //   set applet properties 
      setBackground ( Color.white );
      setFont ( medfont );
      
      prompt1 = new Label ( "Enter an integer, A:  ")  ;
      add ( prompt1 ) ;

      input1 = new TextField ( 20 ) ;
      add ( input1 ) ;
      
      prompt2 = new Label ( "Enter a real number, B: ");
      add ( prompt2 ) ;
      
      input2 = new TextField ( 20 ) ;
      add ( input2 );

      addbutton = new Button ( "          Add   A + B         ");
      addbutton.addActionListener  ( this ) ;
      add ( addbutton ) ;
      
      clearbutton = new Button ( "        Clear        " ) ;
      clearbutton.addActionListener ( this ) ;
      add ( clearbutton ) ;
      
      output = new TextField ( 20 );
      output.setEditable ( false ) ;        // don't allow users to type in area
      add ( output ) ;
   }

/*  This method is called by the browser whenever a Button is clicked.
 *  It uses the event argument to determine which Button it was, and defines
 *        what to do in response.
 */
   public void actionPerformed (ActionEvent event)
   {      
      if ( event.getSource ( ) == addbutton ) 
      {  
          int num1;
          double num2;
          
          // read the numbers that the user typed into the TextFields
         num1 = Integer.parseInt ( input1.getText ( ) );
         num2 = ( new Double (input2.getText ( ))).doubleValue ( ) ;

         output.setText ( new Double (num1 + num2 ).toString ( ));
         }
         
         if ( event.getSource ( ) == clearbutton )
         {  // delete the words from the TextFields and TextArea
            input1.setText ( "" ) ;
            input2.setText ( "" ) ;
            output.setText ( "" ) ;
           }
   }  
}
      


