/*  
 *  Calculator.java
 *   This applet has a simple calculator
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Calculator extends Applet 
			implements ActionListener
{
  Font f = new Font("Dialog", Font.BOLD,18);
  Font f2 = new Font("Dialog", Font.BOLD,14);
  Color lightblue = new Color(153,255,255);
  
  Panel top = new Panel ( ) ;
  Panel keypad = new Panel ( ) ;
 
   int textlength = 20;
  TextField display = new TextField("",textlength);

  Button digits [ ] = new Button[10];
  Button clear = new Button("Clear");
  Button plus = new Button("+");
  Button equal = new Button("=");
   int displaynumber = 0;  

  public void init() 
  { 
   setBackground(lightblue);

    keypad.setLayout(new GridLayout ( 5, 3, 5, 5));
    for (int i=1; i<digits.length; i++)
      { digits[i] = new Button(String.valueOf(i));
        digits[i].setFont(f);
        keypad.add (digits[i]);
        digits[i].addActionListener (this);
      }
    keypad.add ( new Label ( " " ));
    digits[0] = new Button("0");
    digits[0].setFont(f);
    keypad.add (digits[0]);
    digits[0].addActionListener (this);
    keypad.add ( new Label ( " ") );

    clear.addActionListener (this);
    keypad.add(clear);

    plus.addActionListener(this);
    plus.setFont(f2);
    keypad.add(plus);
    
    equal.addActionListener(this);
    equal.setFont(f2);
    keypad.add(equal);

    display.setEditable (false);
    display.setFont(f);
    top.add ( display );
   
   setLayout ( new BorderLayout ( ) );     
    add (top, BorderLayout.NORTH);
    add (keypad, BorderLayout.CENTER);
  }
  
  public void actionPerformed(ActionEvent e) 
  {
      for (int i=0; i<digits.length; i++)
      if (e.getSource ( ) == digits[i])
        { 
          display.setText ( display.getText ( ) + String.valueOf ( i ) );
        }

    if (e.getSource ( ) == clear)
      { displaynumber = 0; display.setText (""); }

    if (e.getSource ( ) == plus)
      {  
         displaynumber = Integer.parseInt ( display.getText ( ) );
         display.setText ( "" );
      }

    if (e.getSource ( ) == equal)
      {  
      displaynumber = displaynumber + Integer.parseInt (display.getText ( ));
      display.setText ( String.valueOf ( displaynumber )); 
        }
  }
}

