/* DisplayEvents.java
 *  This applet teaches students about events by demonstrating what code is 
 *  executed when you press one of two buttons. 
 */ 
 
import java.awt.*; 
import java.awt.event.*; 
 
public class DisplayEvents extends java.applet.Applet 
	                 	implements ActionListener 
{ 
   Panel controlpanel = new Panel ( ); 
   Panel displaypanel = new Panel ( ); 
   Button button1, button2, button3; 
   Label label0, label1,label2,label3, label4, label5 , label6; 
   Label label7, label8, label9;
   Label L [ ] = new Label [ 30 ]; 
   Font plain = new Font ( "SansSerif", Font.PLAIN, 14 ); 
   Font bold = new  Font ("SansSerif", Font.BOLD, 14 ); 
   Color dkgreen = new Color (0, 127, 0);
    
   public void init ( ) 
   { 
      setFont ( plain ); 
      label0 = new Label ( "On the right is an example Java applet");
      label7 = new Label ( "     with two buttons."); 
      label1 = new Label ( "When the browser downloads an applet, ");
      label8 = new Label ( "it executes the initializing code"); 
      label6 = new Label ("(in the declarations and init method)."); 
      controlpanel.add ( label0);  controlpanel.add ( label7 );
      controlpanel.add ( label1 );  controlpanel.add ( label8 );
      controlpanel.add ( label6); 
       
      button1 = new Button("Show initializing code"); 
      button1.setBackground (Color.white ); 
      button1.addActionListener(this); 
      controlpanel.add(button1); 
 
      label9 = new Label ( " " );
      label2 = new Label ( "When the user presses the button marked Green,"); 
      label3 = new Label ( "the actionPerformed method is executed here."); 
      controlpanel.add ( label9 );
      controlpanel.add ( label2 ); controlpanel.add ( label3 ); 
 
      button2 = new Button("                Green               "); 
      button2.setBackground ( Color.white ); 
      button2.addActionListener(this); 
      controlpanel.add(button2); 
 
      label4 = new Label ( "When the user presses the button marked Blue,"); 
      label5 = new Label ( "the actionPerformed method is executed again."); 
      controlpanel.add ( label4 ); controlpanel.add ( label5 ); 
 
      button3 = new Button("                Blue                "); 
      button3.setBackground (Color.white); 
      button3.addActionListener(this); 
      controlpanel.add(button3); 
       
     L[1] = new Label ("import java.awt.*;"); 
     L[2] = new Label ("import java.awt.event.*;"); 
     L[3 ]= new Label ("public class ButtonColors extends java.applet.Applet "); 
     L[4] = new Label ("                                                   implements ActionListener"); 
     L[3].setFont ( bold );  L[4].setFont ( bold ); 
     L[5] = new Label ("{  Button greenbutton, bluebutton;"); 
     L[6] = new Label ("   "); 
     L[7] = new Label ("   public void init ( )"); 
     L[7].setFont ( bold ); 
     L[8] = new Label ("  {  "); 
     L[9 ]= new Label ("     greenbutton = new Button ( \"        Green        \");"); 
     L[10] = new Label ("     greenbutton.addActionListener  ( this ) ;"); 
     L[11] = new Label ("     add (greenbutton ) ; ");     
     L[12] = new Label ("      bluebutton = new Button ( \"        Blue         \" ) ;"); 
     L[13] = new Label ("      bluebutton.addActionListener ( this ) ;"); 
     L[14] = new Label ("      add ( bluebutton ) ; "); 
     L[15] = new Label ("   }"); 
     L[16] = new Label ("   public void actionPerformed (ActionEvent event)"); 
     L[16].setFont ( bold ); 
     L[17] = new Label ("   {  "); 
     L[18] = new Label ("     if ( event.getSource ( ) == greenbutton ) "); 
     L[19] = new Label ("      {  "); 
     L[20] = new Label ("          greenbutton.setBackground ( Color.green ); "); 
     L[21] = new Label ("          bluebutton.setBackground ( Color.white ); "); 
     L[22] = new Label ("        }"); 
     L[23] = new Label ("     if ( event.getSource ( ) == bluebutton ) "); 
     L[24] = new Label ("      {  "); 
     L[25] = new Label ("          bluebutton.setBackground ( Color.blue ); "); 
     L[26] = new Label ("          greenbutton.setBackground ( Color.white ); "); 
     L[27] = new Label ("        }"); 
     L[28] = new Label ("    }  "); 
     L[29] = new Label ("} "); 
 
     displaypanel.setLayout ( new GridLayout ( 29, 1, 0, 0 )); 
     for ( int i=1;  i < L.length; i++ ) 
     {  displaypanel.add ( L[ i ] );   } 
      
     setLayout (new GridLayout ( 1, 2, 5, 5 )); 
     add ( controlpanel ); 
     add ( displaypanel ); 
 
   } 
 
 
   public void actionPerformed (ActionEvent event) 
   { 
      if ( event.getSource ( ) == button1 ) 
      { 
         for ( int i = 1; i < L.length; i++) 
         {  L[ i ].setForeground ( Color.black ); } 
         for ( int i = 5; i < 16; i++) 
         {  L[ i ].setForeground ( Color.red ); } 
       } 
      if ( event.getSource ( ) == button2 ) 
      { 
         for ( int i = 1; i < L.length; i++) 
         {  L[ i ].setForeground ( Color.black ); } 
         for ( int i = 17; i < 23; i++) 
         {  L[ i ].setForeground ( dkgreen ); } 
         button2.setBackground ( dkgreen ); 
         button3.setBackground ( Color.white ); 
       } 
     if ( event.getSource ( ) == button3 ) 
      { 
         for ( int i = 1; i < L.length; i++) 
         {  L[ i ].setForeground ( Color.black ); } 
         for ( int i = 23; i < 28; i++) 
         {  L[ i ].setForeground ( Color.blue ); } 
         button2.setBackground ( Color.white ); 
         button3.setBackground ( Color.blue ); 
       }     
   }   
} 
       
 
 
