/*  
 *  Layout1.java
 *   This applet demonstrates the use of a Border
 *    and a Grid Layout.
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Layout1 extends Applet 
			implements ActionListener
{
  Font f = new Font("Dialog", Font.BOLD,18);
  
  Panel top = new Panel ( ) ;
  Panel board = new Panel ( ) ;
 
  TextField display;    //  the component in the top panel
 
  //  use an array of Buttons for the board panel
  Button digits [ ] = new Button[4];

  public void init() 
  { 
   setBackground ( Color.yellow );
   
// set up top Panel - uses default FlowLayout
    display = new TextField (30 );
    display.setFont ( f );
    top.add ( display );
   
//   set up board Panel
    board.setLayout(new GridLayout ( 2, 2 ));  
    // create the buttons, add them to the board, and add ActionListener
    for ( int i=0; i<digits.length; i++ )
      { digits[i] = new Button( "Button " + i );
        digits[i].setFont(f);
        digits[i].addActionListener (this);
         board.add ( digits[i] );
      }

// set up Applet
   setLayout ( new BorderLayout ( ) );     
    add (top, BorderLayout.NORTH);
    add (board, BorderLayout.CENTER);
  }
  
  public void actionPerformed(ActionEvent e) 
  {
    for (int i=0; i<digits.length; i++)
      {  if (e.getSource ( ) == digits [ i ] )
         { 
          display.setText ( "You pressed Button " + i );
             }
         }
    }
}