import java.awt.*;
import java.applet.*;

class MyPanel extends Panel
{ MyPanel(Label label, Scrollbar scroll)
    { add(label); add(scroll);
    }
}

public class Setting extends Frame implements Runnable
{ String strnumbub="# of Bubbles", strspdbub="Bubble Speed", 
    strspdbun="Bunny Speed", strradbub="Bubble Size";
  Scrollbar barnumbub, barspdbub, barspdbun, barradbub;
  Label labnumbub, labspdbub, labspdbun, labradbub;
  Button closewindow;
  Panel closepanel;
  Thread windowthread;
  Rabbit bun;
  Rising bub;

  final int WIDTH = 200;
  final int HEIGHT = 200;
  
  Setting(Rising bubbles, Rabbit bunny)
    { bun = bunny;
      bub = bubbles;
      setTitle("Change Settings");
      resize(WIDTH, HEIGHT);
      setLayout(new GridLayout(5, 1, 1, 1));
      labnumbub=new Label(strnumbub+" "+bub.maxbubbles);
      barnumbub=new Scrollbar(Scrollbar.HORIZONTAL, bub.maxbubbles, 4, 
			      0, bub.TOTALBUBBLES);
      labradbub=new Label(strradbub+" "+bub.maxradius);
      barradbub=new Scrollbar(Scrollbar.HORIZONTAL, bub.maxradius, 4, 
			      1, bub.TOTALRADIUS);
      labspdbub=new Label(strspdbub+" "+bub.maxstep);
      barspdbub=new Scrollbar(Scrollbar.HORIZONTAL, bub.maxstep, 4, 
			      1, bub.TOTALSTEP);
      labspdbun=new Label(strspdbun+" "+bun.bunnyspeed);
      barspdbun=new Scrollbar(Scrollbar.HORIZONTAL, bun.bunnyspeed, 4, 
			      1, bun.TOTALSPEED);
      add(new MyPanel(labnumbub, barnumbub));
      add(new MyPanel(labradbub, barradbub));
      add(new MyPanel(labspdbub, barspdbub));
      add(new MyPanel(labspdbun, barspdbun));
      add(closewindow = new Button("Close Window"));
      start();
    }

  public boolean handleEvent(Event evt)
    { if (evt.target instanceof Scrollbar)
        { bub.maxbubbles = barnumbub.getValue();
	  bub.maxradius = barradbub.getValue();
	  bub.maxstep = barspdbub.getValue();
	  bun.bunnyspeed = barspdbun.getValue();
	  labnumbub.setText(strnumbub+" "+bub.maxbubbles);
	  labspdbub.setText(strspdbub+" "+bub.maxstep);
	  labradbub.setText(strradbub+" "+bub.maxradius);
	  labspdbun.setText(strspdbun+" "+bun.bunnyspeed);
//	  System.out.println("HandleEvent Setting");
	}
      return super.handleEvent(evt);
    }
    
  public boolean action (Event evt, Object arg)
    { String label = (String) arg;
      if (evt.target instanceof Button)
	{ if (label.equals("Close Window"))
	    hide();
	}
//      System.out.println("Action Setting");
      return true;
    }
  
  public synchronized void start()
    { if (windowthread == null)
	{ windowthread = new Thread(this);
	  windowthread.start();
//	  System.out.println("Start Setting");    
	}
    }
  
  public void stop()
    { windowthread = null;
      dispose();
//      System.out.println("Stop Setting");
    }

  public void run()
    { while (windowthread != null)
	{ try {Thread.sleep(100);} catch (InterruptedException e) {}
//	  System.out.println("Run Setting");
	}
    }
}




